#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "faire_pipeline.h"

int faire_pipeline(char **a,...){
  int tube[2];
  int c;
  va_list l;
  char **u;
  char ***tab;
  pid_t *pidtab;
  int precedent=STDIN_FILENO;
  pid_t pid;

  /*compter le nombre de processus a creer*/
  va_start(l,a);
  for(c=1;;c++){
    u=va_arg(l,char **);
    if( u==NULL )
      break;
  }
  va_end(l);

  tab=malloc(c*sizeof(char **));
  if(tab == NULL)
    return EXIT_FAILURE;

  /* pidtab - le vecteurs de pid de tous les fils*/
  pidtab=malloc(c*sizeof(pid_t));
  if(pidtab == NULL)
    return EXIT_FAILURE;

  c=0;
  tab[c++]=a;

  va_start(l,a);
  for(;;){
    u=va_arg(l,char **);
    if( u == NULL)
      break;
    tab[c++]=u;
  }

  for(int i=0;i<c;i++){
    /*creer le tube si ce n'est pas le dernier fils*/
    if( i < c-1 && pipe(tube)==-1){
      perror("creation de tube");
      exit(EXIT_FAILURE);
    }

    if( (pid = fork()) == -1){
      perror("premier fork");
      exit(EXIT_FAILURE);
    }

    if( pid > 0 ){ /*pere*/
      pidtab[i]=pid;
      if(precedent != STDIN_FILENO)
	close(precedent);
      if( i < c-1 ){ /* si non dernier*/
	close(tube[1]);
	precedent=tube[0];
      }
    }

    if( pid == 0){ /*fils*/
      /*si n'est pas le premier fils*/
      if(precedent != STDIN_FILENO){
	dup2(precedent,STDIN_FILENO);
	printf("precedent [%d] [%s]\n",precedent, *tab[i]);
	close(precedent);
      }
      /*si ce n'est pas le dernier fils*/
      if( i < c-1 ){      
	close(tube[0]); /*ce fils ne lit rien dans le tube*/
	dup2(tube[1],STDOUT_FILENO);
	close(tube[1]);
      }
      printf("[**%s**]\n",*tab[i]);
      fflush(stdout);
      execvp(*tab[i],tab[i]+1);


      perror("exec");
      exit(EXIT_FAILURE);
    }

  }


  free(tab);
  /*
  sleep(3);
  for(int i=0;i<c;i++){
    sleep(3);
    if(pidtab[i]!=-1 &&
       waitpid(pidtab[i],NULL,WNOHANG)>0)
      pidtab[i]=-1;
  }
  */
  return 1;
}
